#include <krab.h>
#include <unistd.h>
#include <sys/types.h>

#define ktr	klocale->translate

Krab::Krab(QWidget *parent, const char *name) :KTopLevelWidget(name)
{
	unsigned int pid;
	QString temp;
	char convert[8];
	
	parent = parent ; // I hate compiler warnings...
	QPopupMenu *file_menu = new QPopupMenu();
	file_menu->insertItem(i18n("&Select input files"), this, SLOT(select_files()));
	file_menu->insertSeparator();
	file_menu->insertItem(i18n("E&xit"), this, SLOT(quit_krabber()));

	QPopupMenu *help_menu = new QPopupMenu();
	help_menu->insertItem(i18n("&Help"), this, SLOT(invokeHelp()));
	help_menu->insertItem(i18n(ktr ( "&About..." ) ), this, SLOT(aboutme()));

	QPopupMenu *action_menu = new QPopupMenu();
	action_menu->insertItem(i18n(ktr("&Delete All Jobs")), this, SLOT(delete_all()));
	action_menu->insertItem(i18n(ktr("Delete &Job")), this, SLOT(delete_some()));
	action_menu->insertSeparator();
//	action_menu->insertItem(i18n(ktr("&Record from Soundcard")), this, SLOT(delete_some()));
//	action_menu->insertSeparator();
	action_menu->insertItem(i18n(ktr("&Scan System")), this, SLOT(system_check()));

//	QPopupMenu *settings_menu = new QPopupMenu();
//	settings_menu->insertItem(i18n(ktr("&Generic Settings")), this, SLOT(settings_gen()));
//	settings_menu->insertItem(i18n(ktr("&CDDB Settings")), this, SLOT(settings_cddb()));

	menuBar = new KMenuBar(this, "menubar");
	menuBar->insertItem(i18n("&File"), file_menu);
	menuBar->insertItem(i18n(ktr("&Action")), action_menu);
//	menuBar->insertItem(i18n(ktr("&Settings")), settings_menu);
	menuBar->insertSeparator();
	menuBar->insertItem(i18n("&Help"), help_menu);
	setMenu(menuBar);

	QPix_tool_1 = new QPixmap( KApplication::kde_icondir() + "/mini/mini-cross.xpm" );
	QPix_tool_2 = new QPixmap( KApplication::kde_datadir() + "/krabber/pics/cross_2.xpm" );
	QPix_tool_3 = new QPixmap( KApplication::kde_icondir() + "/mini/mini-ofolder.xpm" );

	toolBar = new KToolBar(this);
	toolBar->insertButton( *QPix_tool_3, 0, SIGNAL( clicked() ), this, SLOT( select_files() ), TRUE, ktr( "Select Files" ) );
	toolBar->insertSeparator();
	toolBar->insertButton( *QPix_tool_1, 0, SIGNAL( clicked() ), this, SLOT( delete_some() ), TRUE, ktr( "Delete Jobs" ) );
	toolBar->insertButton( *QPix_tool_2, 0, SIGNAL( clicked() ), this, SLOT( delete_all() ), TRUE, ktr( "Delete All Jobs" ) );

	addToolBar(toolBar);

	statusBar = new KStatusBar(this);
	setStatusBar(statusBar);
	statusBar->insertItem( ktr ( "Krabber 0.2.7 is up !" ), 1);

	pid = getpid();
	ostrstream( convert, 8 ) <<pid <<ends;

	tdlist = new TodoList;
	tdlist->tracks     = 0;
	tdlist->grab_mode  = 0;
	tdlist->krabber_process_id= convert;

	view = new KrabWidget(this, "", tdlist);
	setView(view);
	connect( view, SIGNAL(new_status_info(QString)), SLOT(new_status_info_emited(QString)) );
	connect( view, SIGNAL(enable_widgets(bool)), SLOT(enable_widgets(bool)) );	
//	view->test_enviroment(FALSE);

	resize( 675, 502 );
	setMinimumSize( 675, 502 );
	setCaption( "Krabber 0.2.7" );
	enable_widgets( TRUE );
	enabled = TRUE;
}

Krab::~Krab()
{
	delete toolBar;
	delete statusBar;
	delete menuBar;
	delete view;
}
void Krab::new_status_info_emited( QString temp )
{
	statusBar->changeItem( temp, 1);
};

void Krab::aboutme()
{
	KMsgBox::message( this, ktr( "About Krabber 0.2" ), ktr("Krabber 0.2\n\nThis is a frontend for\n  cdparanoia\n  cdda2wav\n  amp\n  8hz-mp3\n  bladeenc\n  l3enc\n  mp3enc\n\nWritten by: Adrian Schrter <942ftas@stud.fh-jena.de>\n") 	);
};

void Krab::invokeHelp()
{
	kapp->invokeHTMLHelp("krabber/krabber.html", "");
}

void Krab::delete_all()
{
	if (!enabled)
		return;
	tdlist->tracks = 0;
	view->todolist_update();
};
void Krab::delete_some()
{
	if (!enabled)
		return;
	unsigned int item;
	if ( tdlist->tracks > 0 )
	{
		item = view->KTabListBox_todo->currentItem();
		view->delete_job( item + 1 );
		view->todolist_update();
		if ( tdlist->tracks > item )
			view->KTabListBox_todo->setCurrentItem( item );
		else if ( tdlist->tracks > 0 )
			view->KTabListBox_todo->setCurrentItem( item - 1 );
	};
};
void Krab::enable_widgets( bool on )
{
	enabled = on;
};
void Krab::system_check()
{
	if (!enabled)
		return;
	view->test_enviroment(TRUE);
};
void Krab::select_files()
{
	if (!enabled)
		return;
	view->select_files();
};
void Krab::settings_gen()
{
	if (!enabled)
		return;

};
void Krab::quit_krabber()
{
	if (!enabled)
		return;
	KApplication::exit();
};
